package softmc.logic;

public class ArrayStore extends N_aryTerm {

    private ArrayStore(Term... terms) {
        super(terms);
    }
    
    public ArrayStore(Term array, Term index, Term value) {
        this(new Term[] { array, index, value });
    }

    public Term getArray() { return terms[0]; }
    public Term getIndex() { return terms[1]; }
    public Term getValue() { return terms[2]; }
    
    public void setArray(Term t) { setTerm(0, t); }
    public void setIndex(Term t) { setTerm(1, t); }
    public void setValue(Term t) { setTerm(2, t); }
    
    @Override
    public String getOp() {
        return "store";
    }
    
    @Override
    public String toString() {
        return String.format("%s.set(%s, %s)", getArray(), getIndex(), getValue());
    }

}
