package softmc.logic;

public abstract class N_aryTerm extends Term {

    protected Term[] terms;

    N_aryTerm(Term[] terms) {
        this.terms = terms;
    }
    
    public Term[] getTerms() {
        return terms;
    } 
    
    public Term getTerm(int idx) {
        return terms[idx];
    }
    
    public void setTerm(int idx, Term t) {
        terms[idx] = t;
    }
    
    public void setTerms(Term[] terms) {
        this.terms = terms;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        for (Term t : terms) {
            sb.append(t).append(" ");
        }
        sb.deleteCharAt(sb.length() - 1);
        return "(" + getOp() + " " + sb.toString() + ")";
    }

    public abstract String getOp();
}
