package softmc.logic;

import softmc.logic.visitors.CloneVisitor;

public abstract class Term implements Cloneable {

    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof Term))
            return false;
        return toString().equals(obj.toString());
    }

    @Override
    public int hashCode() {
        return toString().hashCode();
    }

    @Override
    public Term clone() {
        return new CloneVisitor().clone(this);
    }

    @Override
    public String toString() {
        return getClass().getSimpleName();
    }
    
}
