package softmc.logic;

/**
 * @Immutable
 */
public class Var extends Term {

    private final String varName;
    private final Sort varType;

    Var(String varName, Sort varType) {
        this.varName = varName;
        this.varType = varType;
    }

    public String getVarName() {
        return varName;
    }

    public Sort getVarType() {
        return varType;
    }

    @Override
    public String toString() {
        return varName;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + ((varName == null) ? 0 : varName.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        Var other = (Var) obj;
        if (varName == null) {
            if (other.varName != null)
                return false;
        } else if (!varName.equals(other.varName))
            return false;
        return true;
    }
    
}
