package softmc.logic.visitors;

import korat.utils.reflection.ReflectionUtils;
import korat.utils.visitors.IVisitor;
import korat.utils.visitors.VisitorUtils;
import softmc.logic.BinTerm;
import softmc.logic.N_aryTerm;
import softmc.logic.Term;
import softmc.logic.UnaryTerm;
import softmc.logic.Var;
import softmc.logic.VarModTerm;

/**
 * This one is different than VarRewrapper in that that it doesn't wrap those
 * variables already wrapped in a VarModTerm.
 */
@Deprecated
class FreeVarWrapper implements IVisitor<Term> {
    private Class<? extends VarModTerm> wrapWith;

    public Term wrap(Term termToVisit, Class<? extends VarModTerm> wrapWith) {
        this.wrapWith = wrapWith;
        return VisitorUtils.visit(termToVisit, this);
    }

    public Term visitUnaryTerm(UnaryTerm term) {
        Term innerTerm = VisitorUtils.visit(term.getTerm(), this);
        term.setTerm(innerTerm);
        return term;
    }

    public Term visitBinTerm(BinTerm term) {
        Term lhs = VisitorUtils.visit(term.getLhs(), this);
        Term rhs = VisitorUtils.visit(term.getRhs(), this);
        term.setLhs(lhs);
        term.setRhs(rhs);
        return term;
    }

    public Term visitN_aryTerm(N_aryTerm term) {
        Term[] terms = term.getTerms();
        Term[] newTerms = new Term[terms.length];
        for (int i = 0; i < terms.length; i++) {
            newTerms[i] = VisitorUtils.visit(terms[i], this);
        }
        term.setTerms(newTerms);
        return term;
    }

    /**
     * Don't touch those already wrapped
     */
    public Term visitVarModTerm(VarModTerm term) {
        // clone?
        return term;
    }

    public Term visitVar(Var var) {
        return ReflectionUtils.newInstance(wrapWith, Var.class, var);
    }

    public Term visitTerm(Term term) {
        return term;
    }
}
