package softmc.logic.visitors;

import korat.utils.visitors.IVisitor;
import korat.utils.visitors.VisitorUtils;
import softmc.logic.Add;
import softmc.logic.And;
import softmc.logic.App;
import softmc.logic.ArraySelect;
import softmc.logic.ArrayStore;
import softmc.logic.BoolConst;
import softmc.logic.Div;
import softmc.logic.Eq;
import softmc.logic.Factory;
import softmc.logic.Ge;
import softmc.logic.Gt;
import softmc.logic.Implies;
import softmc.logic.IntConst;
import softmc.logic.Ite;
import softmc.logic.Le;
import softmc.logic.Lt;
import softmc.logic.Mod;
import softmc.logic.Mul;
import softmc.logic.Neq;
import softmc.logic.Not;
import softmc.logic.Or;
import softmc.logic.Sort;
import softmc.logic.Sub;
import softmc.logic.Term;
import softmc.logic.Var;

public class TermTypeInference implements IVisitor<Sort> {
    
    public Sort inferType(Term term) {
        return VisitorUtils.visit(term, this);
    }
    
    public Sort visitApp(App app) { return app.getRetSort(); }    
    public Sort visitIntConst(IntConst intConst) { return Factory.instance.INT_SORT; }
    public Sort visitBoolConst(BoolConst boolConst) { return Factory.instance.BOOL_SORT; }    
    public Sort visitAnd(And and) { return Factory.instance.BOOL_SORT; }
    public Sort visitOr(Or term) { return Factory.instance.BOOL_SORT; }
    public Sort visitEq(Eq term) { return Factory.instance.BOOL_SORT; }
    public Sort visitNeq(Neq term) { return Factory.instance.BOOL_SORT; }
    public Sort visitGe(Ge term) { return Factory.instance.BOOL_SORT; }
    public Sort visitGt(Gt term) { return Factory.instance.BOOL_SORT; }
    public Sort visitLe(Le term) { return Factory.instance.BOOL_SORT; }
    public Sort visitLt(Lt term) { return Factory.instance.BOOL_SORT; }
    public Sort visitImplies(Implies term) { return Factory.instance.BOOL_SORT; }
    public Sort visitIte(Ite term) { return Factory.instance.BOOL_SORT; }
    public Sort visitNot(Not term) { return Factory.instance.BOOL_SORT; }
    public Sort visitVar(Var var) { return var.getVarType(); }
    public Sort visitArrrayStore(ArrayStore term) { return Factory.instance.INT_ARRAY_SORT; }
    public Sort visitArrraySelect(ArraySelect term) { return Factory.instance.INT_SORT; }
    public Sort visitAdd(Add term) { return Factory.instance.INT_SORT; }
    public Sort visitSub(Sub term) { return Factory.instance.INT_SORT; }
    public Sort visitMul(Mul term) { return Factory.instance.INT_SORT; }
    public Sort visitDiv(Div term) { return Factory.instance.INT_SORT; }
    public Sort visitMod(Mod term) { return Factory.instance.INT_SORT; }
}
