package softmc.state;

import java.util.LinkedList;

import softmc.logic.Term;

public class SymStack {

    public static class Entry {
        public final Term sym;
        public final Term expr;

        Entry(Term sym, Term expr) {
            this.expr = expr;
            this.sym = sym;
        }
    }
    
    private LinkedList<Entry> stack = new LinkedList<Entry>();

    public void push(Term sym, Term expr) { stack.push(new Entry(sym, expr)); }
    public void push(Entry e) { stack.push(e); }
    public void insertAt(int idx, Entry e) { stack.add(idx, e); }
    public Entry pop() { return stack.pop(); }    
    public Entry peek() { return stack.peek(); }
    public Entry peekAt(int idx) { return stack.get(idx); }
    
    
    
}
