package softmc.examples;

import java.util.HashMap;
import java.util.Map;

import org.junit.Assert;
import org.junit.Test;

import softmc.ModelChecker;
import softmc.state.GlobalState;
import softmc.tools.Interpreter;
import softmc.tools.Interpreter.ExePath;

public class TestGCD {

    protected ExePath run(int a, int b) throws Exception {
        String className = Examples.class.getName();
        String methodName = "gcd";
        ModelChecker mc = new ModelChecker();
        GlobalState gs = mc.convertToState(className, methodName);
        Map<String, Object> vals = new HashMap<String, Object>();
        vals.put("a0", a);
        vals.put("b1", b);
        return new Interpreter(gs, vals).go();
    }

    @Test
    public void testGCD() throws Exception {
        for (int a = 1; a < 15; a++) 
            for (int b = 1; b < 15; b++)
                testGcd(a, b);
    }
    
    private void testGcd(int a, int b) throws Exception {
        ExePath x = run(a, b);
        int gcd = (Integer) x.getLast().getValue().get("aa2");
        Assert.assertEquals(String.format("gcd(%s,%s) failed", a, b), gcd(a, b), gcd);
    }

    private int gcd(int a, int b) {
        if (b == 0)
            return a;
        return gcd(b, a % b);
    }

}
