package softmc.examples;

import java.util.HashMap;
import java.util.Map;

import org.junit.Assert;
import org.junit.Test;

import softmc.ModelChecker;
import softmc.state.GlobalState;
import softmc.tools.Interpreter;
import softmc.tools.Interpreter.ExePath;

public class TestSqRoot {

    protected ExePath run(int N) throws Exception {
        String className = Examples.class.getName();
        String methodName = "sqRoot";
        ModelChecker mc = new ModelChecker();
        GlobalState gs = mc.convertToState(className, methodName);
        Map<String, Object> vals = new HashMap<String, Object>();
        vals.put("N0", N);
        return new Interpreter(gs, vals).go();
    }

    @Test
    public void testSqRoot() throws Exception {
        for (int i = 1; i < 20; i++) {
            testSqRoot(i);
        }
    }

    private void testSqRoot(int n) throws Exception {
        ExePath x = run(n);
        int r = (Integer) x.getLast().getValue().get("r1");
        Assert.assertTrue(String.format("n = %s, r = %s", n, r), r * r <= n && (r + 1) * (r + 1) > n);
    }

}
